diff --git a/base/server/src/scriptlets/selinux_setup.py b/base/server/src/scriptlets/selinux_setup.py
index 684a4ce2a0d14337f20730399d116aec27c5b186..9c1c5759bf02a8d0f4e1643c524caae8da1b2bd5 100644
--- a/base/server/src/scriptlets/selinux_setup.py
+++ b/base/server/src/scriptlets/selinux_setup.py
@@ -21,9 +21,7 @@
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
 from pkiconfig import pki_selinux_config_ports as ports
-import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
 import selinux
@@ -37,14 +35,15 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
     suffix = "(/.*)?"
 
-    def restore_context(self):
-        selinux.restorecon(master['pki_instance_path'], True)
+    def restore_context(self, master_dict):
+        selinux.restorecon(master_dict['pki_instance_path'], True)
         selinux.restorecon(config.PKI_DEPLOYMENT_LOG_ROOT, True)
-        selinux.restorecon(master['pki_instance_log_path'], True)
-        selinux.restorecon(master['pki_instance_configuration_path'], True)
+        selinux.restorecon(master_dict['pki_instance_log_path'], True)
+        selinux.restorecon(master_dict['pki_instance_configuration_path'], True)
 
-    def spawn(self):
-        if config.str2bool(master['pki_skip_installation']):
+    def spawn(self, deployer):
+        
+        if config.str2bool(deployer.master_dict['pki_skip_installation']):
             config.pki_log.info(log.SKIP_SELINUX_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             return self.rv
@@ -62,46 +61,46 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         while True:
             try:
                 # check first if any transactions are required
-                if len(ports) == 0 and master['pki_instance_name'] == \
+                if len(ports) == 0 and deployer.master_dict['pki_instance_name'] == \
                     config.PKI_DEPLOYMENT_DEFAULT_TOMCAT_INSTANCE_NAME:
-                    self.restore_context()
+                    self.restore_context(master)
                     return self.rv
 
                 # add SELinux contexts when adding the first subsystem
-                if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
-                    util.instance.apache_instance_subsystems() == 1 or\
-                    master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
-                    len(util.instance.tomcat_instance_subsystems()) == 1:
+                if deployer.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
+                    deployer.instance.apache_instance_subsystems() == 1 or\
+                    deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
+                    len(deployer.instance.tomcat_instance_subsystems()) == 1:
 
                     trans = seobject.semanageRecords("targeted")
                     trans.start()
-                    if master['pki_instance_name'] != \
+                    if deployer.master_dict['pki_instance_name'] != \
                         config.PKI_DEPLOYMENT_DEFAULT_TOMCAT_INSTANCE_NAME:
 
                         fcon = seobject.fcontextRecords()
 
                         config.pki_log.info("adding selinux fcontext \"%s\"",
-                        master['pki_instance_path'] + self.suffix,
+                        deployer.master_dict['pki_instance_path'] + self.suffix,
                         extra=config.PKI_INDENTATION_LEVEL_2)
-                        fcon.add(master['pki_instance_path'] + self.suffix,
+                        fcon.add(deployer.master_dict['pki_instance_path'] + self.suffix,
                                  config.PKI_INSTANCE_SELINUX_CONTEXT, "", "s0", "")
 
                         config.pki_log.info("adding selinux fcontext \"%s\"",
-                                            master['pki_instance_log_path'] + self.suffix,
+                                            deployer.master_dict['pki_instance_log_path'] + self.suffix,
                                             extra=config.PKI_INDENTATION_LEVEL_2)
-                        fcon.add(master['pki_instance_log_path'] + self.suffix,
+                        fcon.add(deployer.master_dict['pki_instance_log_path'] + self.suffix,
                                  config.PKI_LOG_SELINUX_CONTEXT, "", "s0", "")
 
                         config.pki_log.info("adding selinux fcontext \"%s\"",
-                                            master['pki_instance_configuration_path'] + self.suffix,
+                                            deployer.master_dict['pki_instance_configuration_path'] + self.suffix,
                                             extra=config.PKI_INDENTATION_LEVEL_2)
-                        fcon.add(master['pki_instance_configuration_path'] + self.suffix,
+                        fcon.add(deployer.master_dict['pki_instance_configuration_path'] + self.suffix,
                                  config.PKI_CFG_SELINUX_CONTEXT, "", "s0", "")
 
                         config.pki_log.info("adding selinux fcontext \"%s\"",
-                                            master['pki_database_path'] + self.suffix,
+                                            deployer.master_dict['pki_database_path'] + self.suffix,
                                             extra=config.PKI_INDENTATION_LEVEL_2)
-                        fcon.add(master['pki_database_path'] + self.suffix,
+                        fcon.add(deployer.master_dict['pki_database_path'] + self.suffix,
                                  config.PKI_CERTDB_SELINUX_CONTEXT, "", "s0", "")
 
                         portRecords = seobject.portRecords()
@@ -112,7 +111,7 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
 
                     trans.finish()
 
-                    self.restore_context()
+                    self.restore_context(deployer.master_dict)
                 break
             except ValueError as e:
                 error_message = str(e)
@@ -128,7 +127,8 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
 
         return self.rv
 
-    def destroy(self):
+    def destroy(self, deployer):
+        
         if not bool(selinux.is_selinux_enabled()):
             config.pki_log.info(log.SELINUX_DISABLED_DESTROY_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
@@ -137,7 +137,7 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_1)
 
         # check first if any transactions are required
-        if len(ports) == 0 and master['pki_instance_name'] == \
+        if len(ports) == 0 and deployer.master_dict['pki_instance_name'] == \
            config.PKI_DEPLOYMENT_DEFAULT_TOMCAT_INSTANCE_NAME:
                return self.rv
         # A maximum of 10 tries to delete the SELinux contexts
@@ -146,39 +146,39 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         while True:
             try:
                 # remove SELinux contexts when removing the last subsystem
-                if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
-                    util.instance.apache_instance_subsystems() == 0 or\
-                    master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
-                    len(util.instance.tomcat_instance_subsystems()) == 0:
+                if deployer.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
+                    deployer.instance.apache_instance_subsystems() == 0 or\
+                    deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
+                    len(deployer.instance.tomcat_instance_subsystems()) == 0:
 
                     trans = seobject.semanageRecords("targeted")
                     trans.start()
 
-                    if master['pki_instance_name'] != \
+                    if deployer.master_dict['pki_instance_name'] != \
                         config.PKI_DEPLOYMENT_DEFAULT_TOMCAT_INSTANCE_NAME:
 
                         fcon = seobject.fcontextRecords()
 
                         config.pki_log.info("deleting selinux fcontext \"%s\"",
-                                     master['pki_instance_path'] + self.suffix,
+                                     deployer.master_dict['pki_instance_path'] + self.suffix,
                                      extra=config.PKI_INDENTATION_LEVEL_2)
-                        fcon.delete(master['pki_instance_path'] + self.suffix , "")
+                        fcon.delete(deployer.master_dict['pki_instance_path'] + self.suffix , "")
 
                         config.pki_log.info("deleting selinux fcontext \"%s\"",
-                                 master['pki_instance_log_path'] + self.suffix,
+                                 deployer.master_dict['pki_instance_log_path'] + self.suffix,
                                  extra=config.PKI_INDENTATION_LEVEL_2)
-                        fcon.delete(master['pki_instance_log_path'] + self.suffix, "")
+                        fcon.delete(deployer.master_dict['pki_instance_log_path'] + self.suffix, "")
 
                         config.pki_log.info("deleting selinux fcontext \"%s\"",
-                                  master['pki_instance_configuration_path'] + self.suffix,
+                                  deployer.master_dict['pki_instance_configuration_path'] + self.suffix,
                                   extra=config.PKI_INDENTATION_LEVEL_2)
-                        fcon.delete(master['pki_instance_configuration_path'] + \
+                        fcon.delete(deployer.master_dict['pki_instance_configuration_path'] + \
                                     self.suffix, "")
 
                         config.pki_log.info("deleting selinux fcontext \"%s\"",
-                                     master['pki_database_path'] + self.suffix,
+                                     deployer.master_dict['pki_database_path'] + self.suffix,
                                      extra=config.PKI_INDENTATION_LEVEL_2)
-                        fcon.delete(master['pki_database_path'] + self.suffix , "")
+                        fcon.delete(deployer.master_dict['pki_database_path'] + self.suffix , "")
 
                         portRecords = seobject.portRecords()
                         for port in ports:
diff --git a/base/server/src/scriptlets/slot_substitution.py b/base/server/src/scriptlets/slot_substitution.py
index 7904762cc6914b3951b4102f10bf66f6bc70a00e..54dc1c870fa3d1d26ab9247393e79cd354be7455 100644
--- a/base/server/src/scriptlets/slot_substitution.py
+++ b/base/server/src/scriptlets/slot_substitution.py
@@ -21,9 +21,6 @@
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
-from pkiconfig import pki_slots_dict as slots
-import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
 
@@ -32,65 +29,66 @@ import pkiscriptlet
 class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
 
-    def spawn(self):
-        if config.str2bool(master['pki_skip_installation']):
+    def spawn(self, deployer):
+        
+        if config.str2bool(deployer.master_dict['pki_skip_installation']):
             config.pki_log.info(log.SKIP_SLOT_ASSIGNMENT_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             return self.rv
         config.pki_log.info(log.SLOT_ASSIGNMENT_SPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
-        util.file.copy_with_slot_substitution(master['pki_source_cs_cfg'],
-                                              master['pki_target_cs_cfg'])
-        util.file.copy_with_slot_substitution(master['pki_source_registry'],
-                                              master['pki_target_registry'],
-                                              uid=0, gid=0, overwrite_flag=True)
-        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
-            util.file.copy_with_slot_substitution(
-                master['pki_source_catalina_properties'],
-                master['pki_target_catalina_properties'],
+        deployer.file.copy_with_slot_substitution(deployer.master_dict['pki_source_cs_cfg'],
+                                                        deployer.master_dict['pki_target_cs_cfg'])
+        deployer.file.copy_with_slot_substitution(deployer.master_dict['pki_source_registry'],
+                                                        deployer.master_dict['pki_target_registry'],
+                                                        uid=0, gid=0, overwrite_flag=True)
+        if deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            deployer.file.copy_with_slot_substitution(
+                deployer.master_dict['pki_source_catalina_properties'],
+                deployer.master_dict['pki_target_catalina_properties'],
                 overwrite_flag=True)
-            util.file.copy_with_slot_substitution(
-                master['pki_source_servercertnick_conf'],
-                master['pki_target_servercertnick_conf'],
+            deployer.file.copy_with_slot_substitution(
+                deployer.master_dict['pki_source_servercertnick_conf'],
+                deployer.master_dict['pki_target_servercertnick_conf'],
                 overwrite_flag=True)
-            util.file.copy_with_slot_substitution(
-                master['pki_source_server_xml'],
-                master['pki_target_server_xml'],
+            deployer.file.copy_with_slot_substitution(
+                deployer.master_dict['pki_source_server_xml'],
+                deployer.master_dict['pki_target_server_xml'],
                 overwrite_flag=True)
-            util.file.copy_with_slot_substitution(
-                master['pki_source_context_xml'],
-                master['pki_target_context_xml'],
+            deployer.file.copy_with_slot_substitution(
+                deployer.master_dict['pki_source_context_xml'],
+                deployer.master_dict['pki_target_context_xml'],
                 overwrite_flag=True)
-            util.file.copy_with_slot_substitution(
-                master['pki_source_tomcat_conf'],
-                master['pki_target_tomcat_conf_instance_id'],
+            deployer.file.copy_with_slot_substitution(
+                deployer.master_dict['pki_source_tomcat_conf'],
+                deployer.master_dict['pki_target_tomcat_conf_instance_id'],
                 uid=0, gid=0, overwrite_flag=True)
-            util.file.copy_with_slot_substitution(
-                master['pki_source_tomcat_conf'],
-                master['pki_target_tomcat_conf'],
+            deployer.file.copy_with_slot_substitution(
+                deployer.master_dict['pki_source_tomcat_conf'],
+                deployer.master_dict['pki_target_tomcat_conf'],
                 overwrite_flag=True)
-            util.file.apply_slot_substitution(
-                master['pki_target_velocity_properties'])
-            util.file.apply_slot_substitution(
-                master['pki_target_subsystem_web_xml'])
+            deployer.file.apply_slot_substitution(
+                deployer.master_dict['pki_target_velocity_properties'])
+            deployer.file.apply_slot_substitution(
+                deployer.master_dict['pki_target_subsystem_web_xml'])
             # Strip "<filter>" section from subsystem "web.xml"
             # This is ONLY necessary because XML comments cannot be "nested"!
-            #util.file.copy(master['pki_target_subsystem_web_xml'],
-            #               master['pki_target_subsystem_web_xml_orig'])
-            #util.file.delete(master['pki_target_subsystem_web_xml'])
+            #deployer.file.copy(deployer.master_dict['pki_target_subsystem_web_xml'],
+            #               deployer.master_dict['pki_target_subsystem_web_xml_orig'])
+            #deployer.file.delete(deployer.master_dict['pki_target_subsystem_web_xml'])
             #util.xml_file.remove_filter_section_from_web_xml(
-            #    master['pki_target_subsystem_web_xml_orig'],
-            #    master['pki_target_subsystem_web_xml'])
-            #util.file.delete(master['pki_target_subsystem_web_xml_orig'])
-            if master['pki_subsystem'] == "CA":
-                util.file.copy_with_slot_substitution(
-                    master['pki_source_proxy_conf'],
-                    master['pki_target_proxy_conf'])
-                util.file.apply_slot_substitution(
-                    master['pki_target_profileselect_template'])
+            #    deployer.master_dict['pki_target_subsystem_web_xml_orig'],
+            #    deployer.master_dict['pki_target_subsystem_web_xml'])
+            #deployer.file.delete(deployer.master_dict['pki_target_subsystem_web_xml_orig'])
+            if deployer.master_dict['pki_subsystem'] == "CA":
+                deployer.file.copy_with_slot_substitution(
+                    deployer.master_dict['pki_source_proxy_conf'],
+                    deployer.master_dict['pki_target_proxy_conf'])
+                deployer.file.apply_slot_substitution(
+                    deployer.master_dict['pki_target_profileselect_template'])
         return self.rv
 
-    def destroy(self):
+    def destroy(self, deployer):
         config.pki_log.info(log.SLOT_ASSIGNMENT_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
         config.pki_log.info("NOTHING NEEDS TO BE IMPLEMENTED",
diff --git a/base/server/src/scriptlets/subsystem_layout.py b/base/server/src/scriptlets/subsystem_layout.py
index f340ead4969bdeb5ff059890edb6a51d1428ed84..c6c89375481fa4c7c126ecbd4a440d5b5cfde6a4 100644
--- a/base/server/src/scriptlets/subsystem_layout.py
+++ b/base/server/src/scriptlets/subsystem_layout.py
@@ -21,8 +21,6 @@
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
-import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
 
@@ -31,91 +29,93 @@ import pkiscriptlet
 class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
 
-    def spawn(self):
-        if config.str2bool(master['pki_skip_installation']):
+    def spawn(self, deployer):
+        
+        if config.str2bool(deployer.master_dict['pki_skip_installation']):
             config.pki_log.info(log.SKIP_SUBSYSTEM_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             return self.rv
         config.pki_log.info(log.SUBSYSTEM_SPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # establish instance-based subsystem logs
-        util.directory.create(master['pki_subsystem_log_path'])
-        util.directory.create(master['pki_subsystem_archive_log_path'])
-        if master['pki_subsystem'] in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
-            util.directory.create(master['pki_subsystem_signed_audit_log_path'])
+        deployer.directory.create(deployer.master_dict['pki_subsystem_log_path'])
+        deployer.directory.create(deployer.master_dict['pki_subsystem_archive_log_path'])
+        if deployer.master_dict['pki_subsystem'] in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
+            deployer.directory.create(deployer.master_dict['pki_subsystem_signed_audit_log_path'])
         # establish instance-based subsystem configuration
-        util.directory.create(master['pki_subsystem_configuration_path'])
-        # util.directory.copy(master['pki_source_conf_path'],
-        #                     master['pki_subsystem_configuration_path'])
+        deployer.directory.create(deployer.master_dict['pki_subsystem_configuration_path'])
+        # deployer.directory.copy(deployer.master_dict['pki_source_conf_path'],
+        #                     deployer.master_dict['pki_subsystem_configuration_path'])
         # establish instance-based Apache/Tomcat specific subsystems
-        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+        if deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             # establish instance-based Tomcat PKI subsystem base
-            if master['pki_subsystem'] == "CA":
-                util.directory.copy(master['pki_source_emails'],
-                                    master['pki_subsystem_emails_path'])
-                util.directory.copy(master['pki_source_profiles'],
-                                    master['pki_subsystem_profiles_path'])
+            if deployer.master_dict['pki_subsystem'] == "CA":
+                deployer.directory.copy(deployer.master_dict['pki_source_emails'],
+                                    deployer.master_dict['pki_subsystem_emails_path'])
+                deployer.directory.copy(deployer.master_dict['pki_source_profiles'],
+                                    deployer.master_dict['pki_subsystem_profiles_path'])
             # establish instance-based Tomcat PKI subsystem logs
             # establish instance-based Tomcat PKI subsystem configuration
-            if master['pki_subsystem'] == "CA":
-                util.file.copy(master['pki_source_flatfile_txt'],
-                               master['pki_target_flatfile_txt'])
-                util.file.copy(master['pki_source_registry_cfg'],
-                               master['pki_target_registry_cfg'])
+            if deployer.master_dict['pki_subsystem'] == "CA":
+                deployer.file.copy(deployer.master_dict['pki_source_flatfile_txt'],
+                               deployer.master_dict['pki_target_flatfile_txt'])
+                deployer.file.copy(deployer.master_dict['pki_source_registry_cfg'],
+                               deployer.master_dict['pki_target_registry_cfg'])
                 # '*.profile'
-                util.file.copy(master['pki_source_admincert_profile'],
-                               master['pki_target_admincert_profile'])
-                util.file.copy(master['pki_source_caauditsigningcert_profile'],
-                               master['pki_target_caauditsigningcert_profile'])
-                util.file.copy(master['pki_source_cacert_profile'],
-                               master['pki_target_cacert_profile'])
-                util.file.copy(master['pki_source_caocspcert_profile'],
-                               master['pki_target_caocspcert_profile'])
-                util.file.copy(master['pki_source_servercert_profile'],
-                               master['pki_target_servercert_profile'])
-                util.file.copy(master['pki_source_subsystemcert_profile'],
-                               master['pki_target_subsystemcert_profile'])
-            elif master['pki_subsystem'] == "KRA":
+                deployer.file.copy(deployer.master_dict['pki_source_admincert_profile'],
+                               deployer.master_dict['pki_target_admincert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_caauditsigningcert_profile'],
+                               deployer.master_dict['pki_target_caauditsigningcert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_cacert_profile'],
+                               deployer.master_dict['pki_target_cacert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_caocspcert_profile'],
+                               deployer.master_dict['pki_target_caocspcert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_servercert_profile'],
+                               deployer.master_dict['pki_target_servercert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_subsystemcert_profile'],
+                               deployer.master_dict['pki_target_subsystemcert_profile'])
+            elif deployer.master_dict['pki_subsystem'] == "KRA":
                 # '*.profile'
-                util.file.copy(master['pki_source_servercert_profile'],
-                               master['pki_target_servercert_profile'])
-                util.file.copy(master['pki_source_storagecert_profile'],
-                               master['pki_target_storagecert_profile'])
-                util.file.copy(master['pki_source_subsystemcert_profile'],
-                               master['pki_target_subsystemcert_profile'])
-                util.file.copy(master['pki_source_transportcert_profile'],
-                               master['pki_target_transportcert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_servercert_profile'],
+                               deployer.master_dict['pki_target_servercert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_storagecert_profile'],
+                               deployer.master_dict['pki_target_storagecert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_subsystemcert_profile'],
+                               deployer.master_dict['pki_target_subsystemcert_profile'])
+                deployer.file.copy(deployer.master_dict['pki_source_transportcert_profile'],
+                               deployer.master_dict['pki_target_transportcert_profile'])
             # establish instance-based Tomcat PKI subsystem registry
             # establish instance-based Tomcat PKI subsystem convenience
             # symbolic links
-            util.symlink.create(master['pki_tomcat_webapps_path'],
-                                master['pki_subsystem_tomcat_webapps_link'])
+            deployer.symlink.create(deployer.master_dict['pki_tomcat_webapps_path'],
+                                deployer.master_dict['pki_subsystem_tomcat_webapps_link'])
         # establish instance-based subsystem convenience symbolic links
-        util.symlink.create(master['pki_instance_database_link'],
-                            master['pki_subsystem_database_link'])
-        util.symlink.create(master['pki_subsystem_configuration_path'],
-                            master['pki_subsystem_conf_link'])
-        util.symlink.create(master['pki_subsystem_log_path'],
-                            master['pki_subsystem_logs_link'])
-        util.symlink.create(master['pki_instance_registry_path'],
-                            master['pki_subsystem_registry_link'])
+        deployer.symlink.create(deployer.master_dict['pki_instance_database_link'],
+                            deployer.master_dict['pki_subsystem_database_link'])
+        deployer.symlink.create(deployer.master_dict['pki_subsystem_configuration_path'],
+                            deployer.master_dict['pki_subsystem_conf_link'])
+        deployer.symlink.create(deployer.master_dict['pki_subsystem_log_path'],
+                            deployer.master_dict['pki_subsystem_logs_link'])
+        deployer.symlink.create(deployer.master_dict['pki_instance_registry_path'],
+                            deployer.master_dict['pki_subsystem_registry_link'])
         return self.rv
 
-    def destroy(self):
+    def destroy(self, deployer):
+        
         config.pki_log.info(log.SUBSYSTEM_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # remove instance-based subsystem base
-        if master['pki_subsystem'] == "CA":
-            util.directory.delete(master['pki_subsystem_emails_path'])
-            util.directory.delete(master['pki_subsystem_profiles_path'])
-        util.directory.delete(master['pki_subsystem_path'])
+        if deployer.master_dict['pki_subsystem'] == "CA":
+            deployer.directory.delete(deployer.master_dict['pki_subsystem_emails_path'])
+            deployer.directory.delete(deployer.master_dict['pki_subsystem_profiles_path'])
+        deployer.directory.delete(deployer.master_dict['pki_subsystem_path'])
         # remove instance-based subsystem logs
-        if master['pki_subsystem'] in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
-            util.directory.delete(master['pki_subsystem_signed_audit_log_path'])
-        util.directory.delete(master['pki_subsystem_archive_log_path'])
-        util.directory.delete(master['pki_subsystem_log_path'])
+        if deployer.master_dict['pki_subsystem'] in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
+            deployer.directory.delete(deployer.master_dict['pki_subsystem_signed_audit_log_path'])
+        deployer.directory.delete(deployer.master_dict['pki_subsystem_archive_log_path'])
+        deployer.directory.delete(deployer.master_dict['pki_subsystem_log_path'])
         # remove instance-based subsystem configuration
-        util.directory.delete(master['pki_subsystem_configuration_path'])
+        deployer.directory.delete(deployer.master_dict['pki_subsystem_configuration_path'])
         # remove instance-based subsystem registry
-        util.directory.delete(master['pki_subsystem_registry_path'])
+        deployer.directory.delete(deployer.master_dict['pki_subsystem_registry_path'])
         return self.rv
